/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "CrystalCPUIDDlg.h"
#include "CustomizeDlg.h"
#include "LoveHammerDlg.h"

// g@\
#include "FeatureDlg.h"
#include "CpuidDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define URL_STR "http://crystalmark.info/index.php?spy=CrystalCPUID"
#define URL_STR "http://crystalmark.info/"

extern int gLanguage;
extern CBitmap gBackBitmap;
extern CBrush gBackBrush;
extern COLORREF gTextColor;
extern BOOL gFlagBack;

static void GetOSInfo(CString& OSName,CString& OSType,CString& OSCSD,CString& OSVersion,CString& OSBuild,CString& OSInfo);
static void ExecuteFile(char* FileName);
static int CheckEnableCPUID();
static void GetCPUID(DWORD id,DWORD* A,DWORD* B,DWORD* C,DWORD* D);

/////////////////////////////////////////////////////////////////////////////

CCrystalCPUIDDlg::CCrystalCPUIDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCrystalCPUIDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCrystalCPUIDDlg)
	m_BrandID = _T("");
	m_CacheL1ITU = _T("");
	m_CacheL1ITUUnit = _T("");
	m_Clock = _T("");
	m_ClockOri = _T("");
	m_CPUName = _T("");
	m_CPUNumber = _T("");
	m_DataRate = _T("");
	m_ExFamily = _T("");
	m_ExFamilyEx = _T("");
	m_ExModel = _T("");
	m_ExStepping = _T("");
	m_Family = _T("");
	m_FamilyEx = _T("");
	m_L1DataCache = _T("");
	m_L1ITUCache = _T("");
	m_L2Cache = _T("");
	m_L2CacheSpeed = _T("");
	m_L2CacheSpeedMHz = _T("");
	m_L3Cache = _T("");
	m_Model = _T("");
	m_Multiplier = _T("");
	m_MultiplierOri = _T("");
	m_NameString = _T("");
	m_OverClock = _T("");
	m_Stepping = _T("");
	m_SystemBus = _T("");
	m_SystemBusOri = _T("");
	m_SystemClock = _T("");
	m_SystemClockOri = _T("");
	m_VendorString = _T("");
	m_HyperThreading = _T("");
	m_Platform = _T("");
	m_CPUType = _T("");
	m_Apic = _T("");
	m_CodeName = _T("");
	m_OS = _T("");
	m_ProcessRule = _T("");
	//}}AFX_DATA_INIT

	hSysInfoLib = NULL;
	SysInfo = NULL;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	if( SysInfo == NULL ){
		ConnectSysInfo(0);
	}
}

void CCrystalCPUIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCrystalCPUIDDlg)
	DDX_Control(pDX, IDC_CPU_CPU_NAME, m_CpuNameC);
	DDX_Control(pDX, IDC_CPU_CLOCK, m_ClockC);
	DDX_Control(pDX, IDC_CPU_CPU_SELECT, m_CPUSelectC);
	DDX_Control(pDX, IDC_CPU_SSE3, m_SSE3C);
	DDX_Control(pDX, IDC_CPU_INTEL_64, m_IA64C);
	DDX_Control(pDX, IDC_CPU_AMD_64, m_AA64C);
	DDX_Control(pDX, IDC_CPU_SSE, m_SSEC);
	DDX_Control(pDX, IDC_CPU_SSE2, m_SSE2C);
	DDX_Control(pDX, IDC_CPU_MMX_EX, m_MMXExC);
	DDX_Control(pDX, IDC_CPU_MMX, m_MMXC);
	DDX_Control(pDX, IDC_CPU_3DNOW, m_3DNowC);
	DDX_Control(pDX, IDC_CPU_3DNOW_EX, m_3DNowExC);
	DDX_Control(pDX, IDC_CPU_HT, m_HTC);
	DDX_Text(pDX, IDC_CPU_BRAND_ID, m_BrandID);
	DDX_Text(pDX, IDC_CPU_CACHE_L1_ITU, m_CacheL1ITU);
	DDX_Text(pDX, IDC_CPU_CACHE_L1_ITU_UNIT, m_CacheL1ITUUnit);
	DDX_Text(pDX, IDC_CPU_CLOCK, m_Clock);
	DDX_Text(pDX, IDC_CPU_CLOCK_ORI, m_ClockOri);
	DDX_Text(pDX, IDC_CPU_CPU_NAME, m_CPUName);
	DDX_Text(pDX, IDC_CPU_CPU_NUMBER, m_CPUNumber);
	DDX_Text(pDX, IDC_CPU_DATA_RATE, m_DataRate);
	DDX_Text(pDX, IDC_CPU_EX_FAMILY, m_ExFamily);
	DDX_Text(pDX, IDC_CPU_EX_FAMILY_EX, m_ExFamilyEx);
	DDX_Text(pDX, IDC_CPU_EX_MODEL, m_ExModel);
	DDX_Text(pDX, IDC_CPU_EX_STEPPING, m_ExStepping);
	DDX_Text(pDX, IDC_CPU_FAMILY, m_Family);
	DDX_Text(pDX, IDC_CPU_FAMILY_EX, m_FamilyEx);
	DDX_Text(pDX, IDC_CPU_L1_D_CACHE, m_L1DataCache);
	DDX_Text(pDX, IDC_CPU_L1_ITU_CACHE, m_L1ITUCache);
	DDX_Text(pDX, IDC_CPU_L2_CACHE, m_L2Cache);
	DDX_Text(pDX, IDC_CPU_L2_CACHE_SPEED, m_L2CacheSpeed);
	DDX_Text(pDX, IDC_CPU_L2_CACHE_SPEED_MHZ, m_L2CacheSpeedMHz);
	DDX_Text(pDX, IDC_CPU_L3_CACHE, m_L3Cache);
	DDX_Text(pDX, IDC_CPU_MODEL, m_Model);
	DDX_Text(pDX, IDC_CPU_MULTIPLIER, m_Multiplier);
	DDX_Text(pDX, IDC_CPU_MULTIPLIER_ORI, m_MultiplierOri);
	DDX_Text(pDX, IDC_CPU_NAME_STRING, m_NameString);
	DDX_Text(pDX, IDC_CPU_OVER_CLOCK, m_OverClock);
	DDX_Text(pDX, IDC_CPU_STEPPING, m_Stepping);
	DDX_Text(pDX, IDC_CPU_SYSTEM_BUS, m_SystemBus);
	DDX_Text(pDX, IDC_CPU_SYSTEM_BUS_ORI, m_SystemBusOri);
	DDX_Text(pDX, IDC_CPU_SYSTEM_CLOCK, m_SystemClock);
	DDX_Text(pDX, IDC_CPU_SYSTEM_CLOCK_ORI, m_SystemClockOri);
	DDX_Text(pDX, IDC_CPU_VENDOR_STRING, m_VendorString);
	DDX_Text(pDX, IDC_CPU_HYPER_THREADING, m_HyperThreading);
	DDX_Text(pDX, IDC_CPU_PLATFORM, m_Platform);
	DDX_Text(pDX, IDC_CPU_TYPE, m_CPUType);
	DDX_Text(pDX, IDC_CPU_APIC, m_Apic);
	DDX_Text(pDX, IDC_CPU_CODE_NAME, m_CodeName);
	DDX_Text(pDX, IDC_CPU_OS, m_OS);
	DDX_Text(pDX, IDC_CPU_PROCESS_RULE, m_ProcessRule);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCrystalCPUIDDlg, CDialog)
	//{{AFX_MSG_MAP(CCrystalCPUIDDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_CPU_CPU_SELECT, OnSelchangeCpuSelect)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_COMMAND(IDM_COPY, OnCopy)
	ON_COMMAND(IDM_REFRESH, OnRefresh)
	ON_COMMAND(IDM_CRYSTAL_DEW_WORLD, OnCrystalDewWorld)
	ON_COMMAND(IDM_CUSTOMIZE, OnCustomize)
	ON_COMMAND(IDM_CPU_INFO_TEXT, OnCpuInfoText)
	ON_COMMAND(IDM_CRYSTAL_CPUID_TEXT, OnCrystalCpuidText)
	ON_COMMAND(IDM_ENGLISH, OnEnglish)
	ON_COMMAND(IDM_JAPANESE, OnJapanese)
	ON_COMMAND(IDM_FEATURE_FLAGS, OnFeatureFlags)
	ON_COMMAND(IDM_CPUID_DETAIL, OnCpuidDetail)
	ON_COMMAND(IDM_LICENSE, OnLicense)
	ON_COMMAND(IDM_READ_ME, OnReadMe)
	ON_WM_CTLCOLOR()
	ON_COMMAND(IDM_HAMMER_LOVE, OnHammerLove)
	ON_COMMAND(IDM_QUERY_PEFORMANCE_FREQUENCY, OnQueryPeformanceFrequency)
	ON_COMMAND(IDM_CPU_SUPPORT_CPU_LIST, OnCpuSupportCpuList)
	ON_COMMAND(IDM_HIDE_ORIGINAL_CLOCK, OnHideOriginalClock)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CpuInfo.dll ̃[hA[h
// - gpIA[h邱Ƃ𐄏Ă܂ -
// CpuInfo ł͂Ȃ SysInfo Ȃ̂ SysInfo.dll ̖cłB

typedef ISysInfo* (*_CreateSysInfo) (DWORD);
typedef void (*_DestroySysInfo) (ISysInfo*);

BOOL CCrystalCPUIDDlg::ConnectSysInfo(DWORD Mode)
{
	hSysInfoLib = LoadLibrary("CpuInfo.dll");
	if(hSysInfoLib != NULL){
		_CreateSysInfo pCreateSysInfo = (_CreateSysInfo) GetProcAddress (hSysInfoLib,"CreateSysInfo");
		SysInfo = pCreateSysInfo(Mode);
		return TRUE;
	}else{
		MessageBox("Not found \"CpuInfo.dll\".");
		exit(0);
		return FALSE;
	}
}

BOOL CCrystalCPUIDDlg::DisconnectSysInfo()
{
	if(hSysInfoLib !=NULL){
		_DestroySysInfo pDestroySysInfo = (_DestroySysInfo) GetProcAddress (hSysInfoLib,"DestroySysInfo");
		pDestroySysInfo(SysInfo);
		FreeLibrary(hSysInfoLib);
		hSysInfoLib = NULL;
		SysInfo = NULL;
		return TRUE;
	}else{
		return FALSE;
	}
}


CCrystalCPUIDDlg::~CCrystalCPUIDDlg()
{
	DisconnectSysInfo();
}

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDDlg

BOOL CCrystalCPUIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);
//	SetIcon(m_hIcon, FALSE);

	m_Mask = 0;
	m_FlagHideOriginalClock = FALSE;

	// INI t@C̏ꏊݒ
	char* ptrEnd;
	::GetModuleFileName(NULL,m_ini, MAX_PATH);
	if ( (ptrEnd = strrchr(m_ini, '.')) != NULL ){
		*ptrEnd = '\0';
		strcat(m_ini, ".ini");
	}
// ̐ݒ
	char str[256];
	GetPrivateProfileString("Setting","Language","jp",str,256,m_ini);
	if( strcmp(str,"en") != 0 ){
		gLanguage = JAPANESE;
	}else{
		gLanguage = ENGLISH;
	}

	if(gLanguage == ENGLISH){
		OnEnglish();
	}else{
		OnJapanese();
	}

	GetPrivateProfileString("Setting","BackgroundImage","",str,256,m_ini);
	CreateWallPaper(1,NULL,str,0);

	GetPrivateProfileString("Setting","TextColor","",str,256,m_ini);
	if( strcmp(str,"") == 0){
		gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	}else{
		gTextColor = atoi(str);
	}

	Refresh(FALSE);

	CMenu *menu = GetMenu();
	menu->RemoveMenu(SC_MAXIMIZE, FALSE);
	menu->RemoveMenu(SC_SIZE, FALSE);

// CPUID ߃T|[g`FbN
	if( ! CheckEnableCPUID() ){
		menu->EnableMenuItem(IDM_FEATURE_FLAGS,MF_GRAYED);
		menu->EnableMenuItem(IDM_CPUID_DETAIL,MF_GRAYED);
	}
// Love Hammer
	DWORD type;
	SysInfo->GetData(LH_GET_TYPE, &type);
	if( type == 7 || type == 8 ){
		menu->EnableMenuItem(IDM_LOVE_HAMMER,MF_ENABLED);
	}
	SetMenu(menu);

	return TRUE;
}

void CCrystalCPUIDDlg::OnPaint() 
{
	CDialog::OnPaint();
}

HCURSOR CCrystalCPUIDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCrystalCPUIDDlg::OnDestroy() 
{
	CDialog::OnDestroy();
}

void CCrystalCPUIDDlg::OnOK() 
{
//	CDialog::OnOK();
}

void CCrystalCPUIDDlg::OnCancel() 
{
	CDialog::OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
// Refresh

void CCrystalCPUIDDlg::Refresh(BOOL flag)
{
	m_CPUName = "";  
	m_VendorString = "";  
	m_NameString = "";  
	m_DataRate = "";  
	m_Clock = "";
	m_SystemBus = "";    
	m_SystemClock = "";    
	m_Multiplier = "";    
	m_ClockOri = "";    
	m_SystemClockOri = "";    
	m_SystemBusOri = "";  
	m_MultiplierOri = "";  
	m_CPUNumber = "";  
	m_Family = "";  
	m_Model = "";  
	m_Stepping = "";  
	m_ExFamily = "";  
	m_FamilyEx = "";  
	m_ExModel = "";  
	m_ExStepping = "";  
	m_OverClock = "";  
	m_L1ITUCache = "";  
	m_L1DataCache = "";  
	m_L2Cache = "";  
	m_L3Cache = "";
	m_L2CacheSpeedMHz = "";
	m_L2CacheSpeed = "";
	m_Apic = "";
	m_BrandID = "";
	m_Platform = "";
	m_CPUType = "";
	m_CodeName = "";
	m_ProcessRule = "";
	m_OS = "";
	m_HyperThreading = "";

	m_MMXC.EnableWindow(FALSE);
	m_MMXExC.EnableWindow(FALSE);
	m_SSEC.EnableWindow(FALSE);
	m_SSE2C.EnableWindow(FALSE);
	m_SSE3C.EnableWindow(FALSE);
	m_3DNowC.EnableWindow(FALSE);
	m_3DNowExC.EnableWindow(FALSE);
	m_HTC.EnableWindow(FALSE);
	m_IA64C.EnableWindow(FALSE);
	m_AA64C.EnableWindow(FALSE);

	UpdateData(FALSE);

	InvalidateRect(NULL,TRUE);
	UpdateWindow();
	BeginWaitCursor();

// CPU Info
	CString cstr;
	char str[256];
	int data;
	DWORD Version,VersionEx;

	SysInfo->GetData(CPU_UPDATE_BASE + m_Mask,(DWORD*)&data);

	SysInfo->GetString(SI_VERSION,str);
	wsprintf(CrystalCPUIDVersion,"%s.%s",CRYSTAL_CPUID_VERSION,str);
	cstr.Format("CrystalCPUID %s",CrystalCPUIDVersion);
	SetWindowText(cstr);

	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
	m_OS = OSName + " " + OSType + " " + OSCSD + " [ " + OSVersion + " Build " + OSBuild + " ]";

	SysInfo->GetString(CPU_VENDOR_STRING,str);		m_VendorString = str;
	if(m_VendorString.GetLength() > 0){
		SysInfo->GetData(CPU_FLAG_BRAND,(DWORD*)&data);
	}
	
	CString vendor;
	SysInfo->GetString(CPU_FULL_NAME,str);			m_CPUName = str;
	SysInfo->GetString(CPU_NAME_STRING,str);		m_NameString = str;

	SysInfo->GetString(CPU_CODE_NAME,str);			m_CodeName = str;
	SysInfo->GetString(CPU_PROCESS_RULE,str);		m_ProcessRule = str;
	SysInfo->GetString(CPU_PLATFORM_NAME,str);		m_Platform = str;
	SysInfo->GetString(CPU_TYPE_NAME,str);			m_CPUType  = str;
	SysInfo->GetData(CPU_NUMBER,(DWORD*)&data);		if(data >0){m_CPUNumber.Format("%d",data);};

	SysInfo->GetString(CPU_FSB_MODE,str);			m_DataRate = str;
	SysInfo->GetString(CPU_CLOCK,str);				if(atof(str)>0.0){m_Clock = str;}
	SysInfo->GetString(CPU_SYSTEM_BUS,str);			if(atof(str)>0.0){m_SystemBus = str;}
	SysInfo->GetString(CPU_SYSTEM_CLOCK,str);		if(atof(str)>0.0){m_SystemClock = str;}
	SysInfo->GetString(CPU_MULTIPLIER,str);			if(atof(str)>0.0){m_Multiplier = str;}

	if( ! m_FlagHideOriginalClock ){
		SysInfo->GetString(CPU_CLOCK_ORI,str);			if(atof(str)>0.0){m_ClockOri = str;}
		SysInfo->GetString(CPU_SYSTEM_CLOCK_ORI,str);	if(atof(str)>0.0){m_SystemClockOri = str;}
		SysInfo->GetString(CPU_SYSTEM_BUS_ORI,str);		if(atof(str)>0.0){m_SystemBusOri = str;}
		SysInfo->GetString(CPU_MULTIPLIER_ORI,str);		if(atof(str)>0.0){m_MultiplierOri = str;}
	}

	int Number = data;
// R{{bNX̐ݒ
	m_CPUSelectC.ResetContent();
	for(int i=1;i <= Number;i++){
		cstr.Format("CPU%2d",i);
		m_CPUSelectC.AddString(cstr);
	}
	m_CPUSelectC.SetCurSel(m_Mask);

	SysInfo->GetData(CPU_VERSION,&Version);
	if(Version != 0){
		m_Family.Format("%X",(Version >> 8) & 0xF);
		m_Model.Format("%X",(Version >> 4) & 0xF);
		m_Stepping.Format("%X",(Version >> 0) & 0xF);
		if(! m_Family.Compare("F")){m_FamilyEx.Format("%02X",(Version >> 20) & 0xFF);}
	//	if(atoi(m_Model) == 0xF){m_ModelEx.Format("%X",(Version >> 16) & 0xF);}
	}
	SysInfo->GetData(CPU_VERSION_EX,&VersionEx);
	if(VersionEx != 0){
		m_ExFamily.Format("%X",(VersionEx >> 8) & 0xF);
		m_ExModel.Format("%X",(VersionEx >> 4) & 0xF);
		m_ExStepping.Format("%X",(VersionEx >> 0) & 0xF);
	//	if(atoi(m_ExFamily) == 0xF){m_ExFamilyEx.Format("%02X",(VersionEx >> 20) & 0xFF);}
	//	if(atoi(m_ExModel) == 0xF){m_ExModelEx.Format("%X",(VersionEx >> 16) & 0xF);}
	}

// OverClock
	if(atof(m_Clock) > 0.0 && atof(m_ClockOri) > 0.0){
		sprintf(str,"%.2f",( atof(m_Clock) / atof(m_ClockOri) ) * 100.0 - 100.0);
		m_OverClock = str;
	}

	SysInfo->GetData(CPU_BRAND_ID,(DWORD*)&data);			if(data > 0){cstr.Format("%02X",data);m_BrandID = cstr;}
	SysInfo->GetData(CPU_APIC,(DWORD*)&data);				if(data >= 0){cstr.Format("%02X",data);m_Apic = cstr;}
	SysInfo->GetData(CPU_HYPER_THREAD_NUM,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_HyperThreading = cstr;}

	SysInfo->GetData(CPU_FLAG_MMX,(DWORD*)&data);			if(data != -1){m_MMXC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_MMX_EX,(DWORD*)&data);		if(data != -1){m_MMXExC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_SSE,(DWORD*)&data);			if(data != -1){m_SSEC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_SSE2,(DWORD*)&data);			if(data != -1){m_SSE2C.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_SSE3,(DWORD*)&data);			if(data != -1){m_SSE3C.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_3DNOW,(DWORD*)&data);			if(data != -1){m_3DNowC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_3DNOW_EX,(DWORD*)&data);		if(data != -1){m_3DNowExC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_HYPER_THREAD,(DWORD*)&data);	if(data != -1){m_HTC.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_IA64,(DWORD*)&data);			if(data != -1){m_IA64C.EnableWindow(data);}
	SysInfo->GetData(CPU_FLAG_AA64,(DWORD*)&data);			if(data != -1){m_AA64C.EnableWindow(data);}

// Cache Info //
	cstr.Empty();m_CacheL1ITU = "L1 I-Cache";m_CacheL1ITUUnit = "KB";
	SysInfo->GetData(CPU_CACHE_L1U,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_CacheL1ITU = "L1 Unified";m_CacheL1ITUUnit = "KB";}
	SysInfo->GetData(CPU_CACHE_L1I,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_CacheL1ITU = "L1 I-Cache";m_CacheL1ITUUnit = "KB";}
	SysInfo->GetData(CPU_CACHE_L1T,(DWORD*)&data);	if(data > 0){cstr.Format("%d",data);m_CacheL1ITU = "L1 T-Cache";m_CacheL1ITUUnit = "KuOps";}
	m_L1ITUCache = cstr;
	SysInfo->GetData(CPU_CACHE_L1D,(DWORD*)&data);
	cstr.Format("%d",data);if(data > 0){m_L1DataCache = cstr;}
	SysInfo->GetData(CPU_CACHE_L2,(DWORD*)&data);
	cstr.Format("%d",data);if(data > 0){m_L2Cache  = cstr;}
	SysInfo->GetData(CPU_CACHE_L3,(DWORD*)&data);
	cstr.Format("%d",data);if(data > 0){m_L3Cache  = cstr;}

	SysInfo->GetString(CPU_CACHE_SPEED,str);		if(atof(str) > 0.0){cstr.Format("%4.2f",atof(str) * atof(m_Clock));	m_L2CacheSpeedMHz  = cstr;}
	SysInfo->GetString(CPU_CACHE_SPEED_STR,str);	if(strcmp(str,"") != 0){m_L2CacheSpeed  = str;}

	DWORD data1,data2;
	SysInfo->GetData(CPU_RDMSR_EAX_1,(DWORD*)&data1);
	SysInfo->GetData(CPU_RDMSR_EDX_1,(DWORD*)&data2);
	cstr.Format("                : %08X %08X",data1,data2);
	m_MSRInfo = cstr;
	SysInfo->GetData(CPU_RDMSR_EAX_2,(DWORD*)&data1);
	SysInfo->GetData(CPU_RDMSR_EDX_2,(DWORD*)&data2);
	cstr.Format(" %08X %08X\r\n",data1,data2);
	m_MSRInfo += cstr;

	UpdateData(FALSE);
	// DisconnectSysInfo();
	EndWaitCursor();
}

void CCrystalCPUIDDlg::OnRefresh() 
{
	Refresh(TRUE);
}

void CCrystalCPUIDDlg::OnSelchangeCpuSelect() 
{
	CString cstr;
	m_CPUSelectC.GetLBText(m_CPUSelectC.GetCurSel(),cstr);
	cstr.Replace("CPU","");
	m_Mask = atoi(cstr) - 1;
	Refresh(TRUE);
}

void CCrystalCPUIDDlg::OnExit() 
{
	OnCancel();
}

void CCrystalCPUIDDlg::OnCpuInfoText(){			ExecuteFile("CpuInfo.txt");		}
void CCrystalCPUIDDlg::OnCrystalCpuidText(){	ExecuteFile("CrystalCPUID.txt");}
void CCrystalCPUIDDlg::OnLicense(){
	if(	gLanguage == JAPANESE ){
		ExecuteFile("COPYRIGHT-ja.txt");
	}else{
		ExecuteFile("COPYRIGHT.txt");
	}
}

void CCrystalCPUIDDlg::OnReadMe() 
{
	if(	gLanguage == JAPANESE ){
		ExecuteFile("ReadMeJ.txt");
	}else{
		ExecuteFile("ReadMe.txt");
	}	
}

/////////////////////////////////////////////////////////////////////////////
// Crystal Dew World \

void CCrystalCPUIDDlg::OnCrystalDewWorld() 
{
	ShellExecute(NULL,NULL,URL_STR,NULL,NULL,SW_SHOWNORMAL);	
}

/////////////////////////////////////////////////////////////////////////////
// Nbv{[h֏Rs[
// - ȂK -

void CCrystalCPUIDDlg::OnCopy() 
{
	UpdateData(TRUE);
	CString clip;
	CString cstr;

clip = "\
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\r\n\
CrystalCPUID %VERSION% (C) 2002-2003 hiyohiyo\r\n\
                    Crystal Dew World [http://crystalmark.info/]\r\n\
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\r\n\
\r\n\
             OS : %OS%\r\n\
           Date : %Date%\r\n\
\r\n\
       CPU Name : %CPUName%\r\n\
  Vendor String : %VendorString%\r\n\
    Name String : %NameString%\r\n\
   Process Rule : %ProcessRule%\r\n\
       Platform : %Platform%\r\n\
       CPU Type : %CPUType%\r\n\
Number(Logical) : %CPUNumber%\r\n\
";
	clip.Replace("%VERSION%",CrystalCPUIDVersion);

	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
	cstr = OSName + " " + OSType + " " + OSCSD;
	clip.Replace("%OS%",cstr);

	SYSTEMTIME st;
	GetLocalTime(&st);
	cstr.Format("%04d/%02d/%02d %d:%02d:%02d",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	clip.Replace("%Date%",cstr);

	if( ! m_CodeName.IsEmpty() ){
		cstr.Format("%s (%s)",m_CPUName,m_CodeName);
	}else{
		cstr = m_CPUName;
	}
	clip.Replace("%CPUName%",cstr);

	clip.Replace("%VendorString%",m_VendorString);
	clip.Replace("%NameString%",m_NameString);
	clip.Replace("%CPUNumber%",m_CPUNumber);
	clip.Replace("%CPUType%",m_CPUType);
	clip.Replace("%Platform%",m_Platform);
	if( ! m_ProcessRule.IsEmpty() ){
		clip.Replace("%ProcessRule%",m_ProcessRule + " um");
	}else{
		clip.Replace("%ProcessRule%",m_ProcessRule);
	}

	if(! m_HyperThreading.IsEmpty()){	clip += "Hyper-Threading : " + m_HyperThreading + "\r\n";}
	if(! m_Family.IsEmpty()){	clip += "         Family : " + m_Family + "\r\n";}
	if(! m_FamilyEx.IsEmpty()){	clip += "       FamilyEx : " + m_FamilyEx + "\r\n";}
	if(! m_ExFamily.IsEmpty()){	clip += "     Generation : " + m_ExFamily + "\r\n";}
	if(! m_Model.IsEmpty()){	clip += "          Model : " + m_Model + "\r\n";}
	if(! m_Stepping.IsEmpty()){	clip += "       Stepping : " + m_Stepping + "\r\n";}
//	if(! m_ModelEx.IsEmpty()){	clip += "        ModelEx : " + m_ModelEx + "\r\n";}
	if(! m_BrandID.IsEmpty()){	clip += "        BrandID : " + m_BrandID + "\r\n";}
	if(! m_Apic.IsEmpty()){		clip += "           APIC : " + m_Apic + "\r\n";}

	clip += "        Feature :";
	if( m_MMXC.IsWindowEnabled() ){clip += " MMX";}
	if( m_SSEC.IsWindowEnabled() ){clip += " SSE";}
	if( m_SSE2C.IsWindowEnabled() ){clip += " SSE2";}
	if( m_SSE3C.IsWindowEnabled() ){clip += " SSE3";}
	if( m_MMXExC.IsWindowEnabled() ){clip += " MMX+";}
	if( m_3DNowC.IsWindowEnabled() ){clip += " 3DNow!";}
	if( m_3DNowExC.IsWindowEnabled() ){clip += " 3DNow!+";}
	if( m_HTC.IsWindowEnabled() ){clip += " HTT";}
	if( m_IA64C.IsWindowEnabled() ){clip += " IA-64";}
	if( m_AA64C.IsWindowEnabled() ){clip += " AA-64";}
	clip += "\r\n";

	if(atof(m_ClockOri) > 0.0){
		clip += "\r\n                    Current        Original\r\n";
	}else{
		clip +="\r\n";
	}
    
	if(atof(m_Clock) > 0.0){
		cstr.Format("%7.2f",atof(m_Clock));
		clip += "          Clock : " + cstr + " MHz";
	}
	if(atof(m_ClockOri) > 0.0){
		cstr.Format("%7.2f",atof(m_ClockOri));
		clip += "     " + cstr + " MHz";
	}
	if(atof(m_Clock) > 0.0){
		clip +="\r\n";
	}

	if(atof(m_SystemClock) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemClock));
		clip += "   System Clock : " + cstr + " MHz";
	}
	if(atof(m_SystemClockOri) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemClockOri));
		clip += "     " + cstr + " MHz";
	}
	if(atof(m_SystemClock) > 0.0){
		clip +="\r\n";
	}

	if(atof(m_SystemBus) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemBus));
		clip += "     System Bus : " + cstr + " MHz";
	}
	if(atof(m_SystemBusOri) > 0.0){
		cstr.Format("%7.2f",atof(m_SystemBusOri));
		clip += "     " + cstr + " MHz";
	}
	if(atof(m_SystemBus) > 0.0){
		clip +="\r\n";
	}

	if(atof(m_Multiplier) > 0.0){
		cstr.Format("%7.2f",atof(m_Multiplier));
		clip += "     Multiplier : " + cstr;
	}
	if(atof(m_MultiplierOri) > 0.0){
		cstr.Format("%7.2f",atof(m_MultiplierOri));
		clip += "         " + cstr;
	}
	if(atof(m_Multiplier) > 0.0){
		clip +="\r\n";
	}

	if(! m_DataRate.IsEmpty()){
		clip += "      Data Rate :    " + m_DataRate + "\r\n";
	}
	
	if(atof(m_ClockOri) > 0.0){
		cstr.Format("%7.2f %%",atof(m_OverClock));
		clip += "     Over Clock : " + cstr + "\r\n";
	}

	if(atoi(m_L1ITUCache) > 0){
		cstr.Format("%4d",atoi(m_L1ITUCache));
		clip += "\r\n     " + m_CacheL1ITU + " : " + cstr + " " + m_CacheL1ITUUnit + "\r\n"; 
	}
	if(atoi(m_L1DataCache) > 0){
		cstr.Format("%4d",atoi(m_L1DataCache));
		clip += "     L1 D-Cache : " + cstr + " KB\r\n";
	}
	if(atoi(m_L2Cache) > 0){
		cstr.Format("%4d",atoi(m_L2Cache));
		clip += "       L2 Cache : " + cstr + " KB [" + m_L2CacheSpeed + ":" + m_L2CacheSpeedMHz + " MHz]\r\n";
	}
	if(atoi(m_L3Cache) > 0){
		cstr.Format("%4d",atoi(m_L3Cache));
		clip += "       L3 Cache : " + cstr + " KB\r\n";
	}

	clip += "\r\n";
	// CPUID W
	DWORD i=0x00;
	DWORD dwEAX,dwEBX,dwECX,dwEDX;
	cstr.Format("       CPUID    : EAX      EBX      ECX      EDX\r\n");
	clip += cstr;
	cstr.Format("       ----------------------------------------------\r\n");
	clip += cstr;

	GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	DWORD MaxCPUID = dwEAX;
	for(i=0;i<=MaxCPUID;i++){
		GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
		cstr.Format("       %08X : %08X %08X %08X %08X\r\n",i,dwEAX,dwEBX,dwECX,dwEDX);
		clip += cstr;
	}

	GetCPUID(0x80000000,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	if(dwEAX > 0x80000000){
		DWORD MaxCPUIDEx = dwEAX;
		for(i=0x80000000;i<=MaxCPUIDEx;i++){
			GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
			cstr.Format("       %08X : %08X %08X %08X %08X\r\n",i,dwEAX,dwEBX,dwECX,dwEDX);
			clip += cstr;
		}
	}

	GetCPUID(0x80860000,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	if(dwEAX > 0x80000000){
		DWORD MaxCPUIDTx = dwEAX;
		for(i=0x80860000;i<=MaxCPUIDTx;i++){
			GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
			cstr.Format("       %08X : %08X %08X %08X %08X\r\n",i,dwEAX,dwEBX,dwECX,dwEDX);
			clip += cstr;
		}
	}
	clip += "\r\n";
	cstr.Format("       MSR      : EAX1     EDX1     EAX2     EDX2\r\n");
	clip += cstr;
	cstr.Format("       ----------------------------------------------\r\n");
	clip += m_MSRInfo;

	LARGE_INTEGER QPF;
	QueryPerformanceFrequency(&QPF);
	cstr.Format("       QPF      : %f MHz\r\n",QPF.QuadPart / 1000.0 / 1000.0);
	clip += cstr;

	if(OpenClipboard())
	{
		HGLOBAL clipbuffer;
		char * buffer;
		EmptyClipboard();
		clipbuffer = GlobalAlloc(GMEM_DDESHARE, clip.GetLength()+1);
		buffer = (char*)GlobalLock(clipbuffer);
		strcpy(buffer, LPCSTR(clip));
		GlobalUnlock(clipbuffer);
		SetClipboardData(CF_TEXT,clipbuffer);
		CloseClipboard();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPUID ߂̎s

static void GetCPUID(DWORD id,DWORD* A,DWORD* B,DWORD* C,DWORD* D)
{
	DWORD dwEAX,dwEBX,dwECX,dwEDX;
	_asm{
		mov eax,id
		cpuid
		mov dwEAX , eax
		mov dwEBX , ebx	
		mov dwECX , ecx
		mov dwEDX , edx
	}
	*A = dwEAX;
	*B = dwEBX;
	*C = dwECX;
	*D = dwEDX;
}

/////////////////////////////////////////////////////////////////////////////
// ύX

void CCrystalCPUIDDlg::OnJapanese() 
{
	gLanguage = JAPANESE;
	CMenu *menu = GetMenu();

	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "t@C (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "ҏW (&P)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "\ (&V)" );
	menu->ModifyMenu( 3 , MF_BYPOSITION | MF_STRING , 3 , "g@\ (&G)" );
	menu->ModifyMenu( 4 , MF_BYPOSITION | MF_STRING , 4 , "wv (&H)" );

	menu->ModifyMenu( IDM_HIDE_ORIGINAL_CLOCK , MF_STRING , IDM_HIDE_ORIGINAL_CLOCK , "IWiNbNƔ{\Ȃ (&H)" );
	menu->ModifyMenu( IDM_CUSTOMIZE , MF_STRING , IDM_CUSTOMIZE , "JX^}CY (&C)" );
	menu->ModifyMenu( IDM_EXIT , MF_STRING , IDM_EXIT , "I (&E)" );
	menu->ModifyMenu( IDM_COPY , MF_STRING , IDM_COPY , "Rs[ (&C)" );
	menu->ModifyMenu( IDM_REFRESH , MF_STRING , IDM_REFRESH , "tbV (&R)" );

	menu->CheckMenuItem(IDM_ENGLISH,MF_UNCHECKED);
	menu->CheckMenuItem(IDM_JAPANESE,MF_CHECKED);
	menu->EnableMenuItem(IDM_ENGLISH,MF_ENABLED);
	menu->EnableMenuItem(IDM_JAPANESE,MF_GRAYED);

	WritePrivateProfileString("Setting","Language","jp",m_ini);

	if( m_FlagHideOriginalClock ){
		menu->CheckMenuItem(IDM_HIDE_ORIGINAL_CLOCK,MF_CHECKED);
	}
	
	SetMenu(menu);
}

void CCrystalCPUIDDlg::OnEnglish() 
{
	gLanguage = ENGLISH;
	CMenu *menu = GetMenu();

	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "File (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "Edit (&P)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "View (&V)" );
	menu->ModifyMenu( 3 , MF_BYPOSITION | MF_STRING , 3 , "Function (&G)" );
	menu->ModifyMenu( 4 , MF_BYPOSITION | MF_STRING , 4 , "Help (&H)" );

	menu->ModifyMenu( IDM_HIDE_ORIGINAL_CLOCK , MF_STRING , IDM_HIDE_ORIGINAL_CLOCK , "Hide Original Clock && Multiplier (&H)" );
	menu->ModifyMenu( IDM_CUSTOMIZE , MF_STRING , IDM_CUSTOMIZE , "Customize (&C)" );
	menu->ModifyMenu( IDM_EXIT , MF_STRING , IDM_EXIT , "Exit (&E)" );
	menu->ModifyMenu( IDM_COPY , MF_STRING , IDM_COPY , "Copy (&C)" );
	menu->ModifyMenu( IDM_REFRESH , MF_STRING , IDM_REFRESH , "Refresh (&R)" );

	menu->CheckMenuItem(IDM_ENGLISH,MF_CHECKED);
	menu->CheckMenuItem(IDM_JAPANESE,MF_UNCHECKED);
	menu->EnableMenuItem(IDM_ENGLISH,MF_GRAYED);
	menu->EnableMenuItem(IDM_JAPANESE,MF_ENABLED);

	WritePrivateProfileString("Setting","Language","en",m_ini);

	if( m_FlagHideOriginalClock ){
		menu->CheckMenuItem(IDM_HIDE_ORIGINAL_CLOCK,MF_CHECKED);
	}

	SetMenu(menu);
}

void CCrystalCPUIDDlg::OnHideOriginalClock() 
{
	CMenu *menu = GetMenu();

	if( m_FlagHideOriginalClock ){
		m_FlagHideOriginalClock = FALSE;
		menu->CheckMenuItem(IDM_HIDE_ORIGINAL_CLOCK,MF_UNCHECKED);
	}else{
		m_FlagHideOriginalClock = TRUE;
		menu->CheckMenuItem(IDM_HIDE_ORIGINAL_CLOCK,MF_CHECKED);
	}
	Refresh(FALSE);
//	WritePrivateProfileString("Setting","HideOriginalClock","1",m_ini);

	SetMenu(menu);
}

/////////////////////////////////////////////////////////////////////////////
// w肳ꂽt@CJ

static void ExecuteFile(char* FileName)
{
	char path[MAX_PATH],file[MAX_PATH];
	char* ptrEnd;
	::GetModuleFileName(NULL,path, MAX_PATH);
	if ( (ptrEnd = strrchr(path, '\\')) != NULL ){
		*ptrEnd = '\0';
	}
	sprintf(file,"%s\\%s",path,FileName);
	ShellExecute(NULL,NULL,file,NULL,NULL,SW_SHOWNORMAL);	
}

/////////////////////////////////////////////////////////////////////////////
// OS ̏擾

static void GetOSInfo(CString& OSName,CString& OSType,CString& OSCSD,CString& OSVersion,CString& OSBuild,CString& OSInfo)
{
	CString cstr;
	OSVERSIONINFOEX osvi;
	BOOL bOsVersionInfoEx;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
	{
		osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
		GetVersionEx( (OSVERSIONINFO *) &osvi);
	}

	switch(osvi.dwPlatformId)
	{
	case VER_PLATFORM_WIN32_WINDOWS:

		if(osvi.dwMinorVersion == 0 && LOWORD(osvi.dwBuildNumber) < 1000){
			OSName = "Windows 95";		
		}else if(osvi.dwMinorVersion == 0 && LOWORD(osvi.dwBuildNumber) >= 1214){
			OSName = "Windows 95 OSR2.5";
		}else if(osvi.dwMinorVersion == 0 && LOWORD(osvi.dwBuildNumber) >= 1212){
			OSName = "Windows 95 OSR2.1";
		}else if(osvi.dwMinorVersion == 0 && LOWORD(osvi.dwBuildNumber) == 1111){
			OSName = "Windows 95 OSR2";
		}else if(osvi.dwMinorVersion == 10 && LOWORD(osvi.dwBuildNumber) == 1998){
			OSName = "Windows 98";
		}else if(osvi.dwMinorVersion == 10 && LOWORD(osvi.dwBuildNumber) > 1998){
			OSName = "Windows 98 SE";
		}else if(osvi.dwMinorVersion == 90){
			OSName = "Windows Me";
		}else{
			OSName = "Windows 9x";
		}

		OSVersion.Format("%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		OSBuild.Format("%d",LOWORD(osvi.dwBuildNumber)); 
		break;

	case VER_PLATFORM_WIN32_NT:
		if(osvi.dwMajorVersion == 3){
			OSName.Format("Windows NT3.%d",osvi.dwMinorVersion);
		}else if(osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0){
			OSName = "Windows NT4";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0){
			OSName = "Windows 2000";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1){
			OSName = "Windows XP";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2){
			OSName = "Windows Server 2003";
		}else{
			OSName.Format("Windows NT%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		}

		if(! (osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2) ){
			if( bOsVersionInfoEx ){
				if( osvi.wProductType == VER_NT_WORKSTATION ){
					if( osvi.wSuiteMask & VER_SUITE_PERSONAL ){
						OSType = "Home";
					}else{
						if(osvi.dwMajorVersion == 5){OSType = "Professional";}
						else if(osvi.dwMajorVersion == 4){OSType = "Workstation";}
					}
				}else if( osvi.wProductType == VER_NT_SERVER ){
					if( osvi.wSuiteMask & VER_SUITE_DATACENTER ){
						OSType = "DataCenter Server";
					}else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE ){
						OSType = "Advanced Server";
					}else{
						OSType = "Server";
					}
				}
			}else{// NT4 SP5 ȉ 
					HKEY hKey;
					char szProductType[80];
					DWORD dwBufLen;
					RegOpenKeyEx( HKEY_LOCAL_MACHINE,
						"SYSTEM\\CurrentControlSet\\Control\\ProductOptions",
						0, KEY_QUERY_VALUE, &hKey );
					RegQueryValueEx( hKey, "ProductType", NULL, NULL,
						(LPBYTE) szProductType, &dwBufLen);
					RegCloseKey( hKey );
					if( lstrcmpi( "WINNT", szProductType) == 0 ){OSType = "Workstation";}
					if( lstrcmpi( "LANMANNT", szProductType) == 0 ){OSType = "Server";}
					if( lstrcmpi( "SERVERNT", szProductType) == 0 ){OSType = "Advanced Server";}
			 }
		}

		OSCSD = osvi.szCSDVersion;
		//OSCSD.Replace("Service Pack ","SP");

		OSVersion.Format("%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		OSBuild.Format("%d",osvi.dwBuildNumber);
				 
		break;
	}
	OSInfo = OSName + " " + OSCSD;
}


void CCrystalCPUIDDlg::OnCustomize() 
{
	CCustomizeDlg dlg(this);
	if( dlg.DoModal() == IDOK )
	{
		char str[256];
		GetPrivateProfileString("Setting","BackgroundImage","",str,256,m_ini);
		CreateWallPaper(1,NULL,str,0);
		Invalidate(TRUE);
	}
}

BOOL CCrystalCPUIDDlg::CreateWallPaper(DWORD Mode,char* FileName,char* ResourceName,COLORREF Color)
{
	gFlagBack = FALSE;
	gBackBitmap.DeleteObject();
	gBackBrush.DeleteObject();

	switch(Mode)
	{
	case 1:
		if( strcmp(ResourceName,"") == 0 ){
			return FALSE;
		}
		if(	gBackBitmap.LoadBitmap(ResourceName) ){
			gBackBrush.CreatePatternBrush(&gBackBitmap);
		}else if( Dib.LoadBmp(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#ifdef USEPNG
		}else if( Dib.LoadPng(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#endif
#ifdef USEJPEG
		}else if( Dib.LoadJpeg(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#endif	
		}else{
			return FALSE;
		}
		gFlagBack = TRUE;
		return TRUE;
		break;
	case 2:
		gBackBrush.CreateSolidBrush(Color);
		return TRUE;
		break;
	case 0:
	default:
		gFlagBack = FALSE;
		return TRUE;
		break;
	}
	return FALSE;
}

HBRUSH CCrystalCPUIDDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}

//////////////////////////////////////////////////////////////////////
// CPU  CPUID / RDTSC T|[gĂ邩𒲂ׂ
//////////////////////////////////////////////////////////////////////
static int CheckEnableCPUID()
{
	// CPUID߂̎gp
	BOOL FlagCPUID;
	DWORD flag_1, flag_2;
	_asm{
			pushfd
			pop		eax
			mov		flag_1, eax
			xor		eax, 00200000h
			push	eax
			popfd
			pushfd
			pop		eax
			mov		flag_2, eax
		}

    if( flag_1 == flag_2){	// CPUIDߎgps
		FlagCPUID = FALSE;
    }else{					// CPUIDߎgp
		FlagCPUID = TRUE;
	}

	return FlagCPUID;
}

void CCrystalCPUIDDlg::OnFeatureFlags() 
{
	CFeatureDlg dlg;
	dlg.DoModal();
}

void CCrystalCPUIDDlg::OnCpuidDetail() 
{
	CCpuidDlg dlg;
	dlg.DoModal();
}

void CCrystalCPUIDDlg::OnHammerLove() 
{
	CLoveHammerDlg dlg(this);
	dlg.DoModal();
}

void CCrystalCPUIDDlg::OnQueryPeformanceFrequency() 
{
	LARGE_INTEGER QPF;
	CString cstr;
	QueryPerformanceFrequency(&QPF);
	cstr.Format("%f MHz",QPF.QuadPart / 1000.0 / 1000.0);
	MessageBox(cstr,"QueryPerformanceFrequency");	
}

void CCrystalCPUIDDlg::OnCpuSupportCpuList() 
{
	ExecuteFile("SupportCPUList.html");
}

